# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AccessControlRulesMode',
    'Architecture',
    'ConfidentialVMEncryptionType',
    'EdgeZoneStorageAccountType',
    'EndpointAccess',
    'EndpointTypes',
    'GalleryApplicationCustomActionParameterType',
    'GalleryApplicationScriptRebootBehavior',
    'GalleryExtendedLocationType',
    'GallerySharingPermissionTypes',
    'HostCaching',
    'HyperVGeneration',
    'OperatingSystemStateTypes',
    'OperatingSystemTypes',
    'ReplicationMode',
    'ResourceIdentityType',
    'StorageAccountType',
    'UefiKeyType',
    'UefiSignatureTemplateName',
]


class AccessControlRulesMode(str, Enum):
    """
    This property allows you to specify whether the access control rules are in Audit mode, in Enforce mode or Disabled. Possible values are: 'Audit', 'Enforce' or 'Disabled'.
    """
    AUDIT = "Audit"
    ENFORCE = "Enforce"
    DISABLED = "Disabled"


class Architecture(str, Enum):
    """
    The architecture of the image. Applicable to OS disks only.
    """
    X64 = "x64"
    ARM64 = "Arm64"


class ConfidentialVMEncryptionType(str, Enum):
    """
    confidential VM encryption types
    """
    ENCRYPTED_VM_GUEST_STATE_ONLY_WITH_PMK = "EncryptedVMGuestStateOnlyWithPmk"
    ENCRYPTED_WITH_PMK = "EncryptedWithPmk"
    ENCRYPTED_WITH_CMK = "EncryptedWithCmk"
    NON_PERSISTED_TPM = "NonPersistedTPM"


class EdgeZoneStorageAccountType(str, Enum):
    """
    Specifies the storage account type to be used to store the image. This property is not updatable.
    """
    STANDARD_LRS = "Standard_LRS"
    STANDARD_ZRS = "Standard_ZRS"
    STANDARD_SS_D_LRS = "StandardSSD_LRS"
    PREMIUM_LRS = "Premium_LRS"


class EndpointAccess(str, Enum):
    """
    This property allows you to specify if the requests will be allowed to access the host endpoints. Possible values are: 'Allow', 'Deny'.
    """
    ALLOW = "Allow"
    DENY = "Deny"


class EndpointTypes(str, Enum):
    """
    This property allows you to specify the Endpoint type for which this profile is defining the access control for. Possible values are: 'WireServer' or 'IMDS'
    """
    WIRE_SERVER = "WireServer"
    IMDS = "IMDS"


class GalleryApplicationCustomActionParameterType(str, Enum):
    """
    Specifies the type of the custom action parameter. Possible values are: String, ConfigurationDataBlob or LogOutputBlob
    """
    STRING = "String"
    CONFIGURATION_DATA_BLOB = "ConfigurationDataBlob"
    LOG_OUTPUT_BLOB = "LogOutputBlob"


class GalleryApplicationScriptRebootBehavior(str, Enum):
    """
    Optional. The action to be taken with regards to install/update/remove of the gallery application in the event of a reboot.
    """
    NONE = "None"
    RERUN = "Rerun"


class GalleryExtendedLocationType(str, Enum):
    """
    It is type of the extended location.
    """
    EDGE_ZONE = "EdgeZone"
    UNKNOWN = "Unknown"


class GallerySharingPermissionTypes(str, Enum):
    """
    This property allows you to specify the permission of sharing gallery. Possible values are: **Private,** **Groups,** **Community.**
    """
    PRIVATE = "Private"
    GROUPS = "Groups"
    COMMUNITY = "Community"


class HostCaching(str, Enum):
    """
    The host caching of the disk. Valid values are 'None', 'ReadOnly', and 'ReadWrite'
    """
    NONE = "None"
    READ_ONLY = "ReadOnly"
    READ_WRITE = "ReadWrite"


class HyperVGeneration(str, Enum):
    """
    The hypervisor generation of the Virtual Machine. Applicable to OS disks only.
    """
    V1 = "V1"
    V2 = "V2"


class OperatingSystemStateTypes(str, Enum):
    """
    This property allows the user to specify whether the virtual machines created under this image are 'Generalized' or 'Specialized'.
    """
    GENERALIZED = "Generalized"
    SPECIALIZED = "Specialized"


class OperatingSystemTypes(str, Enum):
    """
    This property allows you to specify the OS type of the VMs/VMSS for which this profile can be used against. Possible values are: 'Windows' or 'Linux'
    """
    WINDOWS = "Windows"
    LINUX = "Linux"


class ReplicationMode(str, Enum):
    """
    Optional parameter which specifies the mode to be used for replication. This property is not updatable.
    """
    FULL = "Full"
    SHALLOW = "Shallow"


class ResourceIdentityType(str, Enum):
    """
    The type of identity used for the gallery. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove all identities from the gallery.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


class StorageAccountType(str, Enum):
    """
    Specifies the storage account type to be used to store the image. This property is not updatable.
    """
    STANDARD_LRS = "Standard_LRS"
    STANDARD_ZRS = "Standard_ZRS"
    PREMIUM_LRS = "Premium_LRS"
    PREMIUM_V2_LRS = "PremiumV2_LRS"


class UefiKeyType(str, Enum):
    """
    The type of key signature.
    """
    SHA256 = "sha256"
    X509 = "x509"


class UefiSignatureTemplateName(str, Enum):
    """
    The name of the signature template that contains default UEFI keys.
    """
    NO_SIGNATURE_TEMPLATE = "NoSignatureTemplate"
    MICROSOFT_UEFI_CERTIFICATE_AUTHORITY_TEMPLATE = "MicrosoftUefiCertificateAuthorityTemplate"
    MICROSOFT_WINDOWS_TEMPLATE = "MicrosoftWindowsTemplate"
