# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AzureFileShareAccessTier',
    'AzureFileShareAccessType',
    'ContainerGroupIpAddressType',
    'ContainerGroupNetworkProtocol',
    'ContainerGroupPriority',
    'ContainerGroupRestartPolicy',
    'ContainerGroupSku',
    'ContainerNetworkProtocol',
    'DnsNameLabelReusePolicy',
    'GpuSku',
    'IdentityAccessLevel',
    'LogAnalyticsLogType',
    'NGroupUpdateMode',
    'OperatingSystemTypes',
    'Priority',
    'ResourceIdentityType',
    'Scheme',
]


class AzureFileShareAccessTier(str, Enum):
    """
    Access tier for specific share. GpV2 account can choose between TransactionOptimized (default), Hot, and Cool. FileStorage account can choose Premium. Learn more at: https://learn.microsoft.com/en-us/rest/api/storagerp/file-shares/create?tabs=HTTP#shareaccesstier
    """
    COOL = "Cool"
    HOT = "Hot"
    PREMIUM = "Premium"
    TRANSACTION_OPTIMIZED = "TransactionOptimized"


class AzureFileShareAccessType(str, Enum):
    """
     Specifies how Container Groups can access the Azure file share i.e. all CG will share same Azure file share or going to have exclusive file share.
    """
    SHARED = "Shared"
    EXCLUSIVE = "Exclusive"


class ContainerGroupIpAddressType(str, Enum):
    """
    Specifies if the IP is exposed to the public internet or private VNET.
    """
    PUBLIC = "Public"
    PRIVATE = "Private"


class ContainerGroupNetworkProtocol(str, Enum):
    """
    The protocol associated with the port.
    """
    TCP = "TCP"
    UDP = "UDP"


class ContainerGroupPriority(str, Enum):
    """
    The priority of the container group.
    """
    REGULAR = "Regular"
    SPOT = "Spot"


class ContainerGroupRestartPolicy(str, Enum):
    """
    Restart policy for all containers within the container group. 
    - `Always` Always restart
    - `OnFailure` Restart on failure
    - `Never` Never restart
    """
    ALWAYS = "Always"
    ON_FAILURE = "OnFailure"
    NEVER = "Never"


class ContainerGroupSku(str, Enum):
    """
    The SKU for a container group.
    """
    NOT_SPECIFIED = "NotSpecified"
    STANDARD = "Standard"
    DEDICATED = "Dedicated"
    CONFIDENTIAL = "Confidential"


class ContainerNetworkProtocol(str, Enum):
    """
    The protocol associated with the port.
    """
    TCP = "TCP"
    UDP = "UDP"


class DnsNameLabelReusePolicy(str, Enum):
    """
    The value representing the security enum. The 'Unsecure' value is the default value if not selected and means the object's domain name label is not secured against subdomain takeover. The 'TenantReuse' value is the default value if selected and means the object's domain name label can be reused within the same tenant. The 'SubscriptionReuse' value means the object's domain name label can be reused within the same subscription. The 'ResourceGroupReuse' value means the object's domain name label can be reused within the same resource group. The 'NoReuse' value means the object's domain name label cannot be reused within the same resource group, subscription, or tenant.
    """
    UNSECURE = "Unsecure"
    TENANT_REUSE = "TenantReuse"
    SUBSCRIPTION_REUSE = "SubscriptionReuse"
    RESOURCE_GROUP_REUSE = "ResourceGroupReuse"
    NOREUSE = "Noreuse"


class GpuSku(str, Enum):
    """
    The SKU of the GPU resource.
    """
    K80 = "K80"
    P100 = "P100"
    V100 = "V100"


class IdentityAccessLevel(str, Enum):
    """
    The default access level.
    """
    ALL = "All"
    SYSTEM = "System"
    USER = "User"


class LogAnalyticsLogType(str, Enum):
    """
    The log type to be used.
    """
    CONTAINER_INSIGHTS = "ContainerInsights"
    CONTAINER_INSTANCE_LOGS = "ContainerInstanceLogs"


class NGroupUpdateMode(str, Enum):
    MANUAL = "Manual"
    ROLLING = "Rolling"


class OperatingSystemTypes(str, Enum):
    """
    The operating system type required by the containers in the container group.
    """
    WINDOWS = "Windows"
    LINUX = "Linux"


class Priority(str, Enum):
    """
    The priority of the container group.
    """
    REGULAR = "Regular"
    SPOT = "Spot"


class ResourceIdentityType(str, Enum):
    """
    The type of identity used for the NGroup. The type 'SystemAssigned, UserAssigned' includes both an implicitly created identity and a set of user assigned identities. The type 'None' will remove any identities from the NGroup.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"
    NONE = "None"


class Scheme(str, Enum):
    """
    The scheme.
    """
    HTTP = "http"
    HTTPS = "https"
