# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AlertAutoMitigate',
    'AlertRuleStatus',
    'AppServicePlanTier',
    'ConditionalOperator',
    'ManagedServiceIdentityType',
    'RoutingPreference',
    'SslPreference',
]


class AlertAutoMitigate(str, Enum):
    """
    The value that indicates whether the alert should be automatically resolved or not. The default is Disable.
    """
    ENABLE = "Enable"
    """
    The alert should be automatically resolved.
    """
    DISABLE = "Disable"
    """
    The alert should not be automatically resolved.
    """


class AlertRuleStatus(str, Enum):
    """
    Indicates whether the alert is in an enabled state.
    """
    ENABLED = "Enabled"
    """
    The scheduled query rule is enabled
    """
    DISABLED = "Disabled"
    """
    The scheduled query rule is disabled
    """


class AppServicePlanTier(str, Enum):
    """
    The App Service plan tier.
    """
    ELASTIC_PREMIUM = "ElasticPremium"
    """
    Elastic Premium plan
    """
    PREMIUM_V3 = "PremiumV3"
    """
    Dedicated Premium V3 plan
    """


class ConditionalOperator(str, Enum):
    """
    The threshold operator of the alert.
    """
    LESS_THAN = "LessThan"
    """
    The value is less than the specified value.
    """
    GREATER_THAN = "GreaterThan"
    """
    The value is greater than the specified value.
    """
    EQUAL = "Equal"
    """
    The value is equal to the specified value.
    """
    GREATER_THAN_OR_EQUAL = "GreaterThanOrEqual"
    """
    The value is greater than or equal to the specified value.
    """
    LESS_THAN_OR_EQUAL = "LessThanOrEqual"
    """
    The value is less than or equal to the specified value.
    """


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class RoutingPreference(str, Enum):
    """
    Sets the routing preference of the SAP monitor. By default only RFC1918 traffic is routed to the customer VNET.
    """
    DEFAULT = "Default"
    """
    Default routing preference. Only RFC1918 traffic is routed to the customer VNET.
    """
    ROUTE_ALL = "RouteAll"
    """
    Route all traffic to the customer VNET.
    """


class SslPreference(str, Enum):
    """
    Gets or sets certificate preference if secure communication is enabled.
    """
    DISABLED = "Disabled"
    """
    Secure communication is disabled.
    """
    ROOT_CERTIFICATE = "RootCertificate"
    """
    Secure communication is enabled with root certificate.
    """
    SERVER_CERTIFICATE = "ServerCertificate"
    """
    Secure communication is enabled with server certificate.
    """
